#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include "packet.h"


int main() {
   int sock, ret, len;
   char buffer[65535], *data;
   struct sockaddr_in from;
   struct in_addr src, dst;
   struct ifreq ifr;
   char *interface = "eth0";
   struct ip_header_t *ip = (struct ip_header_t *)&buffer;
   struct tcp_header_t *tcp;


   sock = socket(PF_INET, SOCK_RAW, IPPROTO_TCP);

   strncpy(ifr.ifr_name, interface, strlen(interface)+1);

   if(ioctl(sock, SIOCGIFFLAGS, &ifr) < 0) {
      perror("SIOCGIFFLAGS error : ");
      exit(1);
   }

   ifr.ifr_flags |= IFF_PROMISC;

   if (ioctl(sock, SIOCSIFFLAGS, &ifr) < 0) {
      perror("Could not set the PROMISC flag : ");
      exit(1);
   }

   len = sizeof(from);

   while(1) {
      ret = recvfrom(sock, buffer, sizeof(buffer), 0, (struct sockaddr *)&from, &len);

      printf("resive data = %d\n", ret);

      if (ip->protocol != PROTO_TCP)
         continue;

      printf("================ IP header ===============\n");
      src.s_addr = ip->src_ip;
      dst.s_addr = ip->dst_ip;

      printf("Src ip = %s\n", inet_ntoa(src));
      printf("Dst ip = %s\n", inet_ntoa(dst));
      printf("Total length = %d\n", ntohs(ip->length));
      printf("Identification = %d\n", ntohs(ip->id));
      printf("TTL = %d", ip->ttl);
      printf("Checksum = 0x%X\n", ntohs(ip->checksum));


      printf("=============== TCP header ==============\n");
      tcp = (struct tcp_header_t *)(buffer + (4 * ip->hlen));
      printf("Src port = %d\n", ntohs(tcp->src_port));
      printf("Dst port = %d\n", ntohs(tcp->dst_port));
      printf("Sequence number = 0x%X\n", ntohl(tcp->seqnum));
      printf("Acknowledgment number = 0x%X\n", ntohl(tcp->acknum));
      printf("Checksum = 0x%X\n", ntohs(tcp->checksum));



      printf("=============== DATA field ==============\n");
      data = (char *)(buffer + (4 * ip->hlen) + (4 * tcp->hlen));

      while(isprint(*data) || isspace(*data)) {
         printf("%c", *data);
         data++;

      }

      printf("\n\n\n\n\n");
   }

   return 0;
}
