// EventSocket.cpp: implementation of the CEventSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <process.h>
#include "EventSocket.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//  ̺귯 ڵ ʱȭѴ.
WINSOCK2 _startup;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEventSocket::CEventSocket()
{
	m_hSocket = INVALID_SOCKET;
	m_hEvent = m_hClose = m_hThread = 0;
}

CEventSocket::~CEventSocket()
{
	Close();
}

void CEventSocket::Close()
{
	if( m_hSocket != INVALID_SOCKET )
	{
		// ϴ Ʈũ ϰ ´.
		EventSelect( 0 );
		// 带 Ų.
		WSASetEvent( m_hClose );
	}
}

//    ȣǴ  Լ
void CEventSocket::_CloseSocket()
{
	if( m_hEvent ) CloseHandle( m_hEvent );
	if( m_hClose ) CloseHandle( m_hClose );
	closesocket( m_hSocket );
	m_hSocket = INVALID_SOCKET;
}

//  
void CEventSocket::_MonitorThread( LPVOID pParam )
{
	CEventSocket* psk = (CEventSocket*)pParam;

	BOOL bContinue = TRUE;
	WSAEVENT EventToWaitFor[2];
    EventToWaitFor[0] = psk->m_hClose;	//   ̺Ʈ
    EventToWaitFor[1] = psk->m_hEvent;	// Ʈũ ̺Ʈ ޴ ̺Ʈ ü
	
    while( bContinue )
    {
        DWORD dwHandleSignaled = WSAWaitForMultipleEvents( 2,  
			EventToWaitFor, FALSE, INFINITE, TRUE );
		
        //  ̺Ʈ ߻Ͽ°
        switch(dwHandleSignaled)
        {
		case WSA_WAIT_EVENT_0:  // CloseEvent ߻Ͽ.
			// 带 Ѵ.
			bContinue = FALSE;
			break;
		case WSA_WAIT_EVENT_0 + 1: // SocketEvent ߻Ͽ.
			{
			WSANETWORKEVENTS NetEvents;
			// ׵ ߻ ̺Ʈ ޾ƺ.
			int ce = WSAEnumNetworkEvents( psk->m_hSocket, psk->m_hEvent, &NetEvents);
			// ϳ ̻ ̺Ʈ ÿ   ִ.
			if( NetEvents.lNetworkEvents & FD_ACCEPT )
				psk->OnAccept( NetEvents.iErrorCode[FD_ACCEPT_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_CONNECT )
				psk->OnConnect( NetEvents.iErrorCode[FD_CONNECT_BIT] );
			
			if(	NetEvents.lNetworkEvents & FD_WRITE ) 
				psk->OnSend( NetEvents.iErrorCode[FD_WRITE_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_READ )
				psk->OnReceive( NetEvents.iErrorCode[FD_READ_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_CLOSE )
				psk->OnClose( NetEvents.iErrorCode[FD_CLOSE_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_OOB ) 
				psk->OnOutOfBandData( NetEvents.iErrorCode[FD_OOB_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_QOS )
				psk->OnQualityOfService( NetEvents.iErrorCode[FD_QOS_BIT] );
			
			if( NetEvents.lNetworkEvents & FD_GROUP_QOS ) 
				psk->OnGroupQualityOfService( NetEvents.iErrorCode[FD_GROUP_QOS_BIT] );
			}
			break;
		}
	}

	// Close() Լ ȣ Ʒ ڵ尡 ȣǸ 尡 ȴ.
	psk->_CloseSocket();
}

BOOL CEventSocket::GetSockAddr( LPCTSTR lpszAddress, UINT nPort, SOCKADDR_IN* lpSa )
{
	memset(lpSa,0,sizeof(SOCKADDR_IN));

	//   sockAddr ä.
	LPSTR lpszAscii = (LPTSTR)lpszAddress;
	lpSa->sin_family = AF_INET;

	// ־ ּҰ ٸ  ּҷ(Net)   Ѵ.
	if (lpszAscii == NULL)
		lpSa->sin_addr.s_addr = htonl(INADDR_ANY);
	else
		lpSa->sin_addr.s_addr = inet_addr(lpszAscii);

	//  ּҸ  ߴٸ
	if (lpSa->sin_addr.s_addr == INADDR_NONE)
	{
		// ipּҰ ƴ϶ dns̴.
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszAscii);
		if (lphost != NULL)
			lpSa->sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			//      ߻
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}

	// Ʈ Ѵ.
	lpSa->sin_port = htons((u_short)nPort);
	return TRUE;
}

//  Ѵ.
BOOL CEventSocket::Create( UINT nSocketPort /*= 0*/, int nSocketType/*=SOCK_STREAM*/,
		long lEvent /*= FD_READ | FD_WRITE | FD_OOB | FD_ACCEPT | FD_CONNECT | FD_CLOSE*/,
		LPCTSTR lpszSocketAddress /*= NULL*/ )
{
	
	m_hSocket = socket( AF_INET, nSocketType, 0 );
	if( m_hSocket == SOCKET_ERROR )
		return FALSE;

	m_hEvent = WSACreateEvent();
	m_hClose = WSACreateEvent();
	
	if( EventSelect( lEvent ) )
	{
		SOCKADDR_IN saLocal;
		if( GetSockAddr( lpszSocketAddress, nSocketPort, &saLocal ) )
		{
			if( bind( m_hSocket, (PSOCKADDR)&saLocal, sizeof(SOCKADDR) ) != SOCKET_ERROR )
			{
				//   ̺Ʈ óϱ   带 Ѵ.
				m_hThread = (HANDLE)_beginthread( _MonitorThread, 0, (void*)this );
				return TRUE;
			}
		}
	}

	Close();
	return FALSE;
}

// Ŭ̾Ʈ Ͽ Լ
BOOL CEventSocket::Connect( LPCTSTR lpszHostAddress, UINT nHostPort )
{
	SOCKADDR_IN saRemote;
	if( GetSockAddr( lpszHostAddress, nHostPort, &saRemote ) )
	{
		if( connect( m_hSocket, (PSOCKADDR)&saRemote, sizeof(SOCKADDR) ) == SOCKET_ERROR )
		{
			if( WSAGetLastError() == WSAEWOULDBLOCK )
				return TRUE;
		}
	}

	return FALSE;
}

//   Ͽ Accept Լ
BOOL CEventSocket::Accept( CEventSocket& rConnectedSocket, SOCKADDR* lpSockAddr /*= NULL*/, 
		int* lpSockAddrLen /*= NULL*/ )
{
	//  Accept óѴ.
	rConnectedSocket.m_hSocket = accept( m_hSocket, lpSockAddr, lpSockAddrLen );

	if( rConnectedSocket.m_hSocket == INVALID_SOCKET )
		return FALSE;
	
	//  ϰ   ʱȭ
	rConnectedSocket.m_hClose = WSACreateEvent();
	rConnectedSocket.m_hEvent = WSACreateEvent();

	// ⺻   ̺Ʈ ó Ѵٰ 
	rConnectedSocket.EventSelect(); 
	//   ̺Ʈ óϱ   带 Ѵ.
	rConnectedSocket.m_hThread = (HANDLE)_beginthread( _MonitorThread, 0, (void*)&rConnectedSocket );

	//  
	return TRUE;
}