#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <string.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <arpa/inet.h>

#ifndef __USE_GNU 
#define __USE_GNU
#endif 
#include <fcntl.h>

#define MAX_SOCKETBUF_SIZE 2048
#define MAX_USER_COUNT    100
#define MAX_ROOM_COUNT    20

#include "chat_server.h"
#include "packetCode.h"

//   
static int listen_sockfd;
User userList[MAX_USER_COUNT];		// Ʈ
Room roomList[MAX_ROOM_COUNT];		//ȭ Ʈ


int main(int argc,char *argv[])
{
    struct siginfo si;
    sigset_t set;
    int clilen;
    int ret,conn_fd;

    if (argc != 2)
    {
        printf("Usage : ./chat_server [port]\n");
        printf("  : ./chat_server 2005\n");
        exit(0);
    }

    // SIGRTMIN BLOCKǵ Ѵ.
    sigemptyset(&set);
    sigaddset(&set, SIGRTMIN);
    sigprocmask(SIG_BLOCK, &set, NULL);


	//ñ׳ ڵ鷯 ʱȭѴ.
    init_signal_handler();
    //   Ѵ.
    if(get_listener_fd(atoi(argv[1])) < 0) 	//argv[1] = Ʈȣ
    {
        printf("Socket Create error\n");
        exit(0);
    }
    
    initData();

    while(1)
    {
        printf("Ŷ  \n");
        //   ̺Ʈ ٸ. 
        ret = sigwaitinfo(&set, &si);
        if (ret == SIGRTMIN)
        {
            //printf("ok signal %d : %d\n", si.si_fd, si.si_code);
            //   Ͽ ߻ ̺Ʈ accept ȣؼ   Ѵ. 
            if (si.si_fd == listen_sockfd)
            {
                conn_fd=get_connect_fd();
                printf("%d  ޾Ƶ鿴ϴ.\n", conn_fd);
				sendPacket(conn_fd,S2C_SND_CONNECT_OK,"");
            }
            // ׷   Ͽ ̺Ʈ̹Ƿ
            // ͸ о óѴ. 
            else
            {
            	if(si.si_code==POLL_ERR)
            		disconnect(si.si_fd);
            	else
                	procData(si.si_fd);
            }
        }
    }
}


// ó
int procData(int fd)
{
    char buf[MAX_SOCKETBUF_SIZE] = {0x00, };
    int code=0;
    int size=0;

	int roomNum;
	char strRoomNum[4+1];

    //Ŷ  о
    if (recv(fd, buf, 2,0) <= 0)		//о  ̰ 0 ų ,  Ŭ̾Ʈ  Ҿϰ  ̱⶧ Ŭ̾Ʈ  Ѵ.
    {
        disconnect(fd);
    }
    else
    {
		memcpy(&code,&buf[0],sizeof(code));
		memset(&buf,0x00,sizeof(code));

		recv(fd, buf, 2,0);		//  о.
		memcpy(&size,&buf[0],sizeof(size));
		memset(&buf,0x00,sizeof(size));

		recv(fd, buf, size,0);	// о.
		
		printf("code = %d, size = %d, data = %s\n",code,size,buf);
		
		switch(code)
		{
			case C2S_REQ_LOBBY_DATA:
				printf("г : %s Ŭ̾Ʈ ǿ .\n",buf);
				newUserSetting(fd,buf);
				sendRoomData(fd);
				sendUserData(fd);
				sendNewuserInLobby(fd);
				break;
			case C2S_REQ_CREATE_ROOM:
				printf("[%d] Ŭ̾Ʈ %s ȭ  û.\n",fd,buf);
				if((roomNum=createRoom(buf))>0)
				{
					sprintf(strRoomNum,"%d",roomNum);
					sendPacket(fd,S2C_REP_CREATE_ROOM,strRoomNum);
					sendNewRoomData(roomNum);			//  ȭ ˷ش.
				}
				else
					sendPacket(fd,S2C_REP_CREATE_ROOM,"-1");
				break;
			case C2S_IS_POSSIBLE_JOIN_ROOM:
				if(roomList[atoi(buf)-1].userCount<MAXUSER_IN_ROOM)	//ȭ  
					sendPacket(fd,S2C_REP_POSSIBLE_JOIN_ROOM,buf);
				else												//ȭ  Ұ
					sendPacket(fd,S2C_REP_IMPOSSIBLE_JOIN_ROOM,"");
				break;
			case C2S_REQ_ROOM_DATA:
				printf("[%d] Ŭ̾Ʈ %d ȭ濡  ûϿϴ..\n",fd,atoi(buf));
				if(joinChatRoom(fd,atoi(buf)>0))
				{
					userList[fd].state=USER_IN_CHATROOM;		//äù
					userList[fd].roomNum=atoi(buf);				// ȭ 
					delUserInLobby(fd);
				}
				else
					sendPacket(fd,S2C_REJECT_JOIN_ROOM,"");
				break;
			case C2S_SND_CHAT_MSG:
				sendChatMsg(fd,buf);
				break;
			case C2S_REQ_QUIT_ROOM:
				quitRoom(fd);
				userList[fd].state=USER_IN_LOBBY;			//
				userList[fd].roomNum=0;						//ȭ 
				sendPacket(fd,S2C_REP_QUIT_ROOM,"");
				break;
			case C2S_REQ_END:
				break;
		}
    }
    return 0;
}

void sendPacket(int fd,int code,char* data)
{
	char sendBuf[MAX_SOCKETBUF_SIZE];
	int packetSize=strlen(data);

	memset(&sendBuf,0x00,MAX_SOCKETBUF_SIZE);
	memcpy(&sendBuf[0],&code,sizeof(code));								//Ŷ 
	memcpy(&sendBuf[2],&packetSize,sizeof(packetSize));	// 
	memcpy(&sendBuf[4],data,packetSize);		//
	
	printf("[%d] Ŭ̾Ʈ   : [%d] %s\n",fd,code,data);
	if(send(fd,sendBuf,4+packetSize,0)<0)
		puts("Error :: ͸  ߽ϴ.");
}

// 
int disconnect(int fd)
{
	if(userList[fd].state==USER_IN_LOBBY)		//ǿ 
		delUserInLobby(fd);
	else if(userList[fd].state==USER_IN_CHATROOM)	//ȭ ..
		quitRoom(fd);
		
    printf("[%d] Ŭ̾Ʈ  Ͽϴ.\n",fd);
    close(fd);
}

//ο  
void newUserSetting(int fd,char* nickName)
{
	userList[fd].fd=fd;					//
	strcpy(userList[fd].nickName,nickName);		//г
	userList[fd].state=USER_IN_LOBBY;			//
}

 
void sendRoomData(int fd)
{
	int i=0;
	char buf[128];
	
	for(i=0;i<MAX_ROOM_COUNT;i++)
	{
		if(roomList[i].state==ROOM_OPENED)		// ȭ ..
		{
			memset(&buf,0x00,128);
			sprintf(buf,"%d|%s|%d",roomList[i].roomNum,roomList[i].roomName,roomList[i].userCount);
			sendPacket(fd,S2C_REP_LOBBY_ROOM,buf);
		}
	}
	//sprintf(buf,"%d|%s|%d",1,"׽Ʈ ȭ",5);
	//sendPacket(fd,S2C_REP_LOBBY_ROOM,buf);
}

void sendUserData(int fd)
{
	int i=0;
	
	for(i=0;i<MAX_USER_COUNT;i++)
	{
		if(fd!=i && userList[i].state==USER_IN_LOBBY)		//ǿ ִ ϰ..
		{
			sendPacket(fd,S2C_REP_LOBBY_USER,userList[i].nickName);
		}
	}
	//sendPacket(fd,S2C_REP_LOBBY_USER,"");
}

void sendNewuserInLobby(int fd)
{
	int i=0;
	
	for(i=0;i<MAX_USER_COUNT;i++)
	{
		if(fd!=i && userList[i].state==USER_IN_LOBBY)		//ǿ ִ ϰ..
		{
			sendPacket(i,S2C_REP_LOBBY_USER,userList[fd].nickName);
		}
	}	
}

int createRoom(char* roomName)
{
	int i=0;
	char buf[128];
	
	for(i=0;i<MAX_ROOM_COUNT;i++)
	{
		if(roomList[i].state==ROOM_CLOSED)		//ִ( ) ȭϰ
		{
			strcpy(roomList[i].roomName,roomName);
			roomList[i].state=ROOM_OPENED;
			return roomList[i].roomNum;			// ȭ ȣ ش.
		}
	}
	return -1;
}

void sendNewRoomData(int roomNum)
{
	int i=0;
	char buf[128];
	
	memset(&buf,0x00,128);
	sprintf(buf,"%d|%s|%d",roomList[roomNum-1].roomNum,roomList[roomNum-1].roomName,roomList[roomNum-1].userCount);	
	
	for(i=0;i<MAX_USER_COUNT;i++)
	{
		if(userList[i].state==USER_IN_LOBBY)		//ǿ ִ Ŭ̾Ʈϰ..
		{
			sendPacket(userList[i].fd,S2C_REP_LOBBY_ROOM,buf);
		}
	}
}

int joinChatRoom(int fd,int roomNum)
{
	int index=roomNum-1;
	int i;
	int checkInserted=0;
	
	if(roomList[index].userCount<MAXUSER_IN_ROOM)	//ȭ  
	{
		for(i=0;i<MAXUSER_IN_ROOM;i++)
		{
			if(checkInserted==0 && roomList[index].userIndex[i]==0)		//ִ ̸..
			{
				roomList[index].userIndex[i]=fd;
				roomList[index].userCount++;
				checkInserted=1;
			}
			else if(roomList[index].userIndex[i]!= fd && roomList[index].userIndex[i]!=0)			
			{
				// ȭ濡 ִ ڵ鿡 ο ڰ  ˸.
				sendPacket(roomList[index].userIndex[i],S2C_ADD_USER_IN_ROOM,userList[fd].nickName);
				// ȭ濡  ڿ  ȭ濡 ִ ڸ ˷ش.
				sendPacket(fd,S2C_ADD_USER_IN_ROOM,userList[roomList[index].userIndex[i]].nickName);
			}
				
		}
		return 1;
	}
	else
		return -1;
}

void delUserInLobby(int fd)
{
	int i=0;
	
	for(i=0;i<MAX_USER_COUNT;i++)
	{
		if(userList[i].state==USER_IN_LOBBY)		//ǿ ִ ڵ鿡
		{
			sendPacket(fd,S2C_SND_DELUSER_IN_LOBBY,userList[i].nickName);
		}
	}
}

void sendChatMsg(int fd,char* chatMsg)
{
	int index=userList[fd].roomNum-1;
	int i;
	for(i=0;i<MAXUSER_IN_ROOM;i++)
	{
		if(roomList[index].userIndex[i]!= fd && roomList[index].userIndex[i]!=0)			//ڽ  ȭ濡 ִ ڵ鿡Ը..
			sendPacket(roomList[index].userIndex[i],S2C_SND_CHAT_MSG,chatMsg);
	}
}

void quitRoom(int fd)
{
	int index=userList[fd].roomNum-1;
	int i;
	
	for(i=0;i<MAXUSER_IN_ROOM;i++)
	{
		if(roomList[index].userIndex[i]==fd)		// ҷ Ŭ̾Ʈ ã´.
		{
			roomList[index].userIndex[i]=0;
			roomList[index].userCount--;
		}
		else if(roomList[index].userIndex[i]!=fd && roomList[index].userIndex[i]!=0)			// ȭ濡 ִ ڵ鿡Ը..
		{
			sendPacket(roomList[index].userIndex[i],S2C_SND_DELUSER_IN_ROOM,userList[fd].nickName);
		}
	}
	
	if(roomList[index].userCount<=0)
		resetRoom(index);
}

// ʱȭ
void initData()
{
	int i;
	for(i=0;i<MAX_USER_COUNT;i++)
		resetUser(i);

	for(i=0;i<MAX_ROOM_COUNT;i++)
		resetRoom(i);
}
				  
//  
void resetUser(int index)
{
	memset(&userList[index],0x00,sizeof(User));
}

//ȭ  
void resetRoom(int index)
{
	memset(&roomList[index],0x00,sizeof(Room));
	roomList[index].roomNum=index+1;
}
	
// ñ׳ ڵ鷯 Ѵ. SIGIO ߻  RTS overflow ó  ڵ鷯 ȴ. 
int init_signal_handler()
{
    struct sigaction sigact,pipe_sig;
    
    sigemptyset(&sigact.sa_mask);
    sigact.sa_flags = SA_SIGINFO;
    sigact.sa_restorer = NULL;
    sigact.sa_handler = do_sigio;
    
    sigemptyset(&pipe_sig.sa_mask);    
    pipe_sig.sa_handler = do_sigpipe;
    pipe_sig.sa_flags = 0;
    
    //SIGIO ڵ鷯 
    if (sigaction(SIGIO, &sigact, NULL) < 0)
    {
        printf("sigio handler error\n");
        exit(0);
    }
    
    //SIGPIPE ڵ鷯 
    if (sigaction(SIGPIPE, &pipe_sig, NULL) < 0)
    {
        puts ("signal(SIGPIPE) error\n");
        exit(0);
    }
    
}

//  (listen socket) ϰ, RTS  ϵ Ѵ.
// Ϲ socket -> bind -> listen  ģ.
int get_listener_fd(int port)
{
    int clilen;
    int state;

    struct sockaddr_in serveraddr;
    clilen = sizeof(serveraddr) ;
    
    //TCP  Ѵ.
    listen_sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (listen_sockfd < 0)
    {
        printf("Socket create error\n");
        return -1;    
    }

    bzero(&serveraddr, sizeof(serveraddr));
    serveraddr.sin_family = AF_INET;
    serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
    serveraddr.sin_port = htons(port);

	//ε
    state = bind (listen_sockfd, (struct sockaddr *)&serveraddr, sizeof(serveraddr));
    if (state < 0)
    {
        printf("Bind error\n");
        return -1;
    }
    state = listen(listen_sockfd, 5);
    if (state < 0)
    {
        printf("Listen error\n");
        return -1;
    }
    printf("Listen Socket[%d] Ǿϴ.\n", listen_sockfd);
    return setup_sigio(listen_sockfd);
}

// accept ̿ؼ Ŭ̾Ʈ  .  
//   ڿ ؼ setup_sigio_listeners()Լ ̿ؼ RTS ϵ Ѵ. 
int get_connect_fd()
{
    int sockfd;
    socklen_t clilen; 
    struct sockaddr_in clientaddr;

    clilen = sizeof(clientaddr) ;
    sockfd = accept(listen_sockfd, (struct sockaddr *)&clientaddr, 
                    &clilen);
    if(sockfd < 0)
    {
        printf("Acceft error\n");
        return -1;
    }
    //msoinfo[sockfd] = clientaddr;
    
    setup_sigio_listeners(sockfd);
    return sockfd;
}

// ڷ ־  fd ؼ RTSϵ .
int setup_sigio(int fd)
{
    if (fcntl(fd, F_SETFL, O_RDWR|O_NONBLOCK|O_ASYNC) < 0)
    {
        printf("Nonblocking error\n");
        return -1;
    }
    if (fcntl(fd, F_SETSIG, SIGRTMIN) < 0)
    {
        printf("Couldn't set signal %d on %d\n", SIGRTMIN, fd);
        return -1;
    }    
    if (fcntl(fd, F_SETOWN, getpid()) < 0)
    {
        printf("Could'nt set owner %d on %d\n", getpid(), fd);    
        return -1;
    }
    
    return 0;
}

// setup_sigio  Լ
void setup_sigio_listeners(int fd)
{
    if (setup_sigio(fd) != 0)
    {
        printf("setup sigio error : %d\n", fd);
        exit(0);
    }
}

// RTS overflow ó ڵ鷯
void do_sigio(int signo)
{
    printf("SIGIO : RTS signal queue overflow\n");
}

void do_sigpipe(int signo)
{
    printf("SIG PIPE : PIPE Signal Error\n");
}
